#include "XMain.h"
#include "SMain.h"



#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <sys/file.h>


#define BITMAPDEPTH 1
#define TOO_SMALL 0
#define BIG_ENOUGH 1
#define	MIN(a,b)	(a<b ? a:b)

int screen_num;

void	writefile_xy(int *xcor, int *ycor, int *counter, char *name);
void	readfile_xy(char *name, int *xcor, int *ycor, int *counter);
void	draw_graphics2(Window win, GC gcmine, unsigned int width, unsigned int height, Visual *vis);
void	draw_graphics1(Window win, GC gcmine, unsigned int width, unsigned int height, Visual *vis);


static 	char *progname; /* name this program was invoked by */
BYTE 	zoom[4*FILE_SIZE+1024];
int	save_data_flag = FALSE;

void	ShowImage(char image_name[200], char data_file_name[200], int flag)
{
/*flag = true => full version input data
  flag = false=> no data input, no button press checks only expose */

	int *block, count = 0;
	XSetWindowAttributes attributes;
	XColor color[256];
	XStandardColormap cmap_info;
	unsigned long width, height;	/* window size */
	unsigned long x, y; 	/* window position */
	unsigned int border_width = 4;	/* four pixels */
	unsigned int display_width, display_height;
	unsigned int icon_width, icon_height;
	Colormap colormap;
	Visual *vis;
	XVisualInfo template,*template1;
	XVisualInfo *vlist,vinfo_template,*v;
	long template_mask;
	unsigned long attrib_mask;
	XEvent report;
	GC gc_show, gc1, gc2;
	XFontStruct *font_info;
	int neve,iii,x1,y1;
	int savex[1000],savey[1000],counter;
	XPoint points[200];
	char *display_name = NULL;
	int ii,jj;
	int number,window_size = BIG_ENOUGH;	/* or TOO_SMALL to display contents */
	FILE *examp = NULL;
	char *input_file;
	int datafile;
	char *fontname = "9x15", dummy[2200];
	XGCValues values1, values2;
	unsigned long valuemask = 0;
        int i,fdim,inputdatasize,n;
        struct stat statbuf;
   	
	progname = "ann_show_image";
	save_data_flag = FALSE;
	
	/* open the files */
	if( (datafile = open(image_name, 0)) == -1){
		ErrorHandler(94, FILE_OPEN_ERROR, 0);
		return;
	}
	if( data_file_name[0] != '\0' ){
		save_data_flag = TRUE;
		if( (examp=fopen("/usr/tmp/.exemplars", "w")) == NULL ){
			ErrorHandler(94, FILE_OPEN_ERROR, 1);
                	return;
                }
	}

        fdim = open(image_name,O_RDONLY,0644);
        fstat(fdim,&statbuf);
        switch( statbuf.st_size ){
                case (FILE_SIZE340-256):
                        if (read(datafile, orig1, FILE_SIZE340-256) != FILE_SIZE340-256){
                                fprintf(stderr, "\ncannot read in the data\n");
                                exit(1);
                        }
                        orig = &(orig1[0]);
                        width  = 340;
                        height = 340;
                        break;
                case FILE_SIZE340:
                        if (read(datafile, orig1, FILE_SIZE340) != FILE_SIZE340){
                                fprintf(stderr, "\ncannot read in the data\n");
                                exit(1);
                        }
                        orig = &(orig1[256]);
                        width  = 340;
                        height = 340;
                        break;
                case (FILE_SIZE256-256):
                        if (read(datafile, orig1, FILE_SIZE256-256) != (FILE_SIZE256-256) ){
                                fprintf(stderr, "\ncannot read in the data\n");
                                exit(1);
                        }
                        orig = &(orig1[0]);
                        width  = 256;
                        height = 256;
                        break;
                case FILE_SIZE256:
                        if (read(datafile, orig1, FILE_SIZE256) != FILE_SIZE256){
                                fprintf(stderr, "\ncannot read in the data\n");
                                exit(1);
                        }
                        orig = &(orig1[256]);
                        width  = 256;
                        height = 256;
                        break;
        }
        close(fdim);
image_width = width;
image_height= height;
	
	for (ii=0;ii<256;ii++) color[ii].pixel=ii;
	XQueryColors(dpy,DefaultColormap(dpy, screen_num),color,256);
	for (ii=0;ii<11;ii++)
		color[ii].flags = DoRed | DoGreen | DoBlue;
		color[0].red=color[0].green =color[0].blue = 0 ;
		color[1].red=(255<<8);color[1].green =(100<<8);color[1].blue = 0 ;
		color[2].red=(100<<8);color[2].green =(100<<8);color[2].blue = (100<<8) ;
		color[3].red=(100<<8);color[3].green =0;color[3].blue = (255<<8) ;
		color[4].red=0;color[4].green =(255<<8);color[4].blue = (100<<8) ;
	for (ii=11;ii<256;ii++){
		color[ii].red =
		color[ii].green =
		color[ii].blue = (ii << 8) ;
		color[ii].flags = DoRed | DoGreen | DoBlue;
	}

	/* get screen size from display structure macro */
	screen_num = DefaultScreen(dpy);
	display_width = DisplayWidth(dpy, screen_num);
	display_height = DisplayHeight(dpy, screen_num);

	/* Note that in a real application, x and y would default to 0
	 * but would be settable from the command line or resource database.  
	 */
	x = y = 100;

	/*; create opaque window */
	vis = DefaultVisual(dpy,screen_num);
	vis->class = StaticGray;
	template.class = StaticGray;
	template_mask = 0;
	attrib_mask = 0;
	attrib_mask |= CWColormap;
	template_mask |= VisualClassMask;
	template1 = XGetVisualInfo(dpy,template_mask,&template,&number);
	
	colormap = XCreateColormap(dpy,RootWindow(dpy,screen_num), 
				DefaultVisual(dpy,screen_num),AllocAll);
	XStoreColors(dpy,colormap,color,256);
        XQueryColors(dpy,colormap,color,256);
 
	attributes.colormap = colormap;
	win0 = XCreateWindow(dpy,RootWindow(dpy,screen_num),x, y, 
	width, height,1,8,CopyFromParent, DefaultVisual(dpy,screen_num),
					attrib_mask,&attributes);
	win1 = XCreateWindow(dpy,RootWindow(dpy,screen_num),
		x+300, y+300, 2*width, 2*height,1,8,CopyFromParent, 
		DefaultVisual(dpy,screen_num), attrib_mask,&attributes);

	XSetWindowColormap(dpy,win0,colormap);
	XSetWindowColormap(dpy,win1,colormap);

	/* Select event types wanted */
	XSelectInput(dpy, win1, ExposureMask );
	XSelectInput(dpy, win0, ExposureMask | KeyPressMask |
		 EnterWindowMask | LeaveWindowMask | 
		ButtonPressMask |ButtonReleaseMask |Button2MotionMask| 
		ButtonMotionMask | StructureNotifyMask);


	if ((font_info = XLoadQueryFont(dpy,fontname)) == NULL)
	{
		(void) fprintf( stderr, "%s: Cannot open 9x15 font\n", 
				progname);
		exit( -1 );
	}



	gc1 = XCreateGC(dpy, win0, valuemask, &values1);
	XSetFont(dpy, gc1, font_info->fid);
	XSetForeground(dpy, gc1, BlackPixel(dpy,screen_num));
	XSetBackground(dpy, gc1, WhitePixel(dpy,screen_num));

	gc_show  =
	gc2 = XCreateGC(dpy, win0, valuemask, &values2);
	XSetFont(dpy, gc2, font_info->fid);
	XSetForeground(dpy, gc2, 255);
	XSetBackground(dpy, gc2, BlackPixel(dpy,screen_num));

	/* Display window */
	XMapWindow(dpy, win0);
	XMapSubwindows(dpy, win0);

	if(!flag){
		draw_graphics2(win1, gc_show, width, height,vis);
		draw_graphics1(win0, gc_show, width, height,vis);
	}	
	/* get events, use first to display text and graphics */
	while(flag)  {
		XNextEvent(dpy, &report);
		switch  (report.type) {
		case Expose:
			/* unless this is the last contiguous expose,
			 * don't draw the window */
			if (report.xexpose.count != 0)
				break;
			if (report.xexpose.window = win1)
				draw_graphics2(win1, gc_show, width, height,vis);
			draw_graphics1(win0, gc_show, width, height,vis);			
			break;
		case ButtonPress:
			switch  (report.xbutton.button){
			case Button1:
				x1=report.xbutton.x;
				y1=report.xbutton.y;
				block=get_exemplar(x1,y1);
				if( count < num_exemplars ){
					for (iii=0;iii<25;iii++){
						if( save_data_flag ) fprintf(examp,"%lf ", (double )block[iii]/255.0);
						Training[count].Input[iii] = (double )block[iii]/255.0;
						Training[count].Target[iii] = 0.0;
/*						printf("%.4f, %.4f\n ", Training[count].Input[iii], (float )block[iii]/255.0);*/
					}
					if( save_data_flag ) fprintf(examp,"\t%lf\n",0.0);
				}
				count++;
				printf("%d\n", count);
				break;
			case Button2:
			        x1=report.xbutton.x;
				y1=report.xbutton.y;
                                block=get_exemplar(x1,y1);
				if( count < num_exemplars ){
					for (iii=0;iii<25;iii++){
						if( save_data_flag ) fprintf(examp,"%lf ", (double )block[iii]/255.0);
						Training[count].Input[iii] = (double )block[iii]/255.0;
						Training[count].Target[iii] = 1.0;
/*						printf("%.4f, %.4f\n ", Training[count].Input[iii], (float )block[iii]/255.0);*/
					}
					if( save_data_flag ) fprintf(examp,"\t%lf\n",1.0);
				}
				count++;
				printf("%d\n", count);
                                break;	
			case Button3:
				XUnloadFont(dpy, font_info->fid);
				XFreeGC(dpy, gc1);
				XFreeGC(dpy, gc2);
				XDestroyWindow(dpy, win0);
				XDestroyWindow(dpy, win1);
				if( save_data_flag ){
					fclose(examp);
					count = MIN(count, num_exemplars);
					sprintf(dummy, "echo %%%d > %s;cat /usr/tmp/.exemplars >> %s", count, data_file_name, data_file_name);
					system(dummy);
				}
				return;
			}
			break;
		default:
			break;
		} /* end switch */
	} /* end while */

}



void	draw_graphics1(Window win, GC gcmine, unsigned int width, unsigned int height, Visual *vis)
{
	XImage *xi;
	
	xi = XCreateImage(dpy, vis /*DefaultVisual(dpy, screen_num)*/,
		8, ZPixmap, 0, orig, width, height, 8, 0);
		

	XPutImage(dpy, win, gcmine, xi, 0,0, 0,0,width ,height );
	XFlush(dpy);

}

void    draw_graphics2(Window win, GC gcmine, unsigned int width, unsigned int height, Visual *vis) 
{
        XImage *xi;
	
        xi = XCreateImage(dpy, vis, 8, ZPixmap, 0, zoom,width*2 ,
		height*2, 8, 0);

        XPutImage(dpy, win, gcmine, xi, 0,0, 0,0, 
			width*2, height*2);
	XFlush(dpy);			
}

void	readfile_xy(char *name, int *xcor, int *ycor, int *counter)
{
FILE *fd;
int i,fdim,inputdatasize,n;
struct stat statbuf;
int *xptr,*yptr; 
        
	int tmpx,tmpy;
	FILE *fopen();
        if(open(name,O_RDONLY,0644)==0){
                printf("unable to open file %s \n",name);
                exit(-1);
        }

        fdim = open(name,O_RDONLY,0644);
        fstat(fdim,&statbuf);
        inputdatasize = statbuf.st_size;
        close(fdim);
        *counter = n = inputdatasize/8;
        xptr = xcor /*= (int *)calloc(n,sizeof(int))*/; 
        yptr = ycor /*= (int *)calloc(n,sizeof(int))*/; 
	if((fd=fopen(name,"r"))== NULL){
		printf("unable to create file %s \n",name);
		exit(-1);
	}
	*counter = getw(fd);
       for(i=0; i<n; i++){
           tmpx = getw(fd);
           tmpy = getw(fd);
           *xptr++ = tmpx;
           *yptr++ = tmpy;
       }
       fclose(fd);

}

void	writefile_xy(int *xcor, int *ycor, int *counter, char *name)
{
FILE *fd;
int n,tmpx,tmpy,i;
int *xptr,*yptr;

        xptr = xcor;
        yptr = ycor;
        n = *counter;
        printf("\n %s \n" , name);

	if((fd=fopen(name,"w"))==NULL){
		printf("\nunable to create file %s \n",name);
		exit(-1);
	}
	putw(*counter,fd);
       for(i=0; i<n; i++){
       tmpx = *(xptr++);
       tmpy = *(yptr++);
       putw(tmpx,fd);
       putw(tmpy,fd);
       }
       fclose(fd);
}

int *get_exemplar(int x1, int y1)
{
	int i,j;
	static bluck[25];

	for ( i = -2; i < 3; ++i ) 
	     	for ( j = -2; j < 3; ++j ) {
			bluck[(i+2)*5+(j+2)]= orig[(x1+i)*image_width+(y1+j)];
/*			printf("hello = %d\n", orig[(x1+i)*340+(y1+j)]);*/
		}


	return (bluck);
}
