        /********************************************************
         *                                                      *
         *      ARTIFICIAL   NEURAL   NETWORK   SOFTWARE        *
         *                                                      *
         *      By Andrea Hadjiprocopis                         *
         *                                                      *
         *              1992/93                                 *
         *                                                      *
         ********************************************************/



#define ALLOCATE_CHANS          1       /* function Allocate_Chans of  */
#define CREATE_NEURON_INP       2       /* function CreateNode   */
#define CREATE_NEURON_OUT       3       /* function CreateNode   */
#define MALLOC_ERROR            4       /* malloc, calloc returns NULL */
#define OUT_OF_RANGE		5	/* */
#define PREVIOUS_NODE_ERROR	6	/* the previous node to the one has no channel allocated	*/
#define NEXT_NODE_ERROR		7	/* the next node to the one has no neuron pointer */
#define	WRONG_PARAMETERS	8	/* wrong number or kind of params */
#define CHANNEL_INPUT		9
#define	CHANNEL_OUTPUT		10 	/* FAILED TO READ OR WRITE A CHHANEL */
#define	ACTION_TIMED_OUT	11	/* Action timed out or iterations in loop exceeded preset limit */
#define ALLOCATE_PROC		12 	/* Allocate process for parchan out */
#define EMPTY_CHAN_LIST		13	/* Char list empty		*/
#define	CREATE_NEURON_NODE	14	/* CreateNeuron returned NULL */
#define FILE_OPEN_ERROR		15
#define	UNEXPECTED_EOF		16
#define	NOT_MAPPED_YET		17	/* tryin to use net without allocating it */
